package com.zhili.stationcontrol.chargeserver.handler;

import com.zhili.stationcontrol.chargeserver.dto.ChargeMessage;
import com.zhili.stationcontrol.util.BytesUtil;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToByteEncoder;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2022/10/24 10:42
 */
public class ChargeMessageEncoder extends MessageToByteEncoder<ChargeMessage> {
    public static final byte[] START = {(byte) 0xaa, (byte) 0xf5};
    public static final int baseLen = 9;

    @Override
    protected void encode(ChannelHandlerContext channelHandlerContext, ChargeMessage message, ByteBuf byteBuf) throws Exception {
        //写入起始字节（2）
        byteBuf.writeBytes(START);
        //写入长度（2）
        int len = baseLen + message.getData().length;
        byte[] lenBytes = BytesUtil.fromIntWithLowerFirst(len, 2);
        byteBuf.writeBytes(lenBytes);
        //写入版本(1)
        byteBuf.writeByte(message.getVersion());
        //写入序列号域（1）
        byteBuf.writeByte(message.getSerialNo());
        //写入命令（2）
        byte[] commandBytes = BytesUtil.fromIntWithLowerFirst(message.getCommand(), 2);
        byteBuf.writeBytes(commandBytes);
        //写入数据（n）
        byteBuf.writeBytes(message.getData());
        //写入校验和（1）
        byte[] checkSumObj = new byte[2 + message.getData().length];
        byte[] command = BytesUtil.fromIntWithLowerFirst(message.getCommand(), 2);
        byte[] data = message.getData();
        for (int i = 0; i < command.length; i++) {
            checkSumObj[i] = command[i];
        }
        for (int i = 0; i < data.length; i++) {
            checkSumObj[command.length + i] = data[i];
        }
        byte b = BytesUtil.sumCheck(checkSumObj);
        byteBuf.writeByte(b);
    }
}
