package com.zhili.stationcontrol.chargeserver.util;

import com.zhili.stationcontrol.chargeserver.dto.ChargeMessage;
import io.netty.channel.Channel;
import io.netty.channel.group.ChannelGroup;
import io.netty.channel.group.ChannelMatcher;
import io.netty.channel.group.DefaultChannelGroup;
import io.netty.util.AttributeKey;
import io.netty.util.concurrent.GlobalEventExecutor;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2022/10/24 16:41
 */
public class ChargeCenter {
    static final ChannelGroup channelGroup = new DefaultChannelGroup(GlobalEventExecutor.INSTANCE);

    public static void add(Channel ch) {
        channelGroup.add(ch);
    }

    public static void mark(Channel ch, String key, Object value) {
        Channel channel = channelGroup.find(ch.id());
        channel.attr(AttributeKey.valueOf(key)).set(value);
    }

    public static void send(String key, Object value, ChargeMessage msg) {
        channelGroup.writeAndFlush(msg, new ChannelMatcher() {
            @Override
            public boolean matches(Channel channel) {
                try {
                    Object deviceNo = channel.attr(AttributeKey.valueOf(key)).get();
                    return deviceNo.equals(value);
                } catch (Exception e) {
                    return false;
                }
            }
        });
    }
}
