package com.zhili.stationcontrol.controller;

import com.zhili.stationcontrol.chargeserver.dto.QueryChargeDto;
import com.zhili.stationcontrol.chargeserver.dto.SetRatesDto;
import com.zhili.stationcontrol.chargeserver.dto.StartChargeDto;
import com.zhili.stationcontrol.chargeserver.dto.StopChargeDto;
import com.zhili.stationcontrol.service.ChargeService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2022/10/27 10:51
 */
@RestController
@Slf4j
public class ChargeController {
    @Autowired
    ChargeService chargeService;

    @GetMapping(value = "/test")
    public Object test() {
        return "123";
    }

    @PostMapping(value = "/startChargeImmediatelyUtilFull")
//    "66792204020001"
    public Object startChargeImmediatelyUtilFull(@RequestBody StartChargeDto startDto) {
        log.info("StartChargeDto:" + startDto);
        return chargeService.startImmediatelyUtilFull(startDto.getDeviceNo(), startDto.getGunNo(), startDto.getStopPwd(), startDto.getUserId(), startDto.getChrgId());
    }

    @PostMapping(value = "/stopChargeImmediately")
    public Object stopChargeImmediately(@RequestBody StopChargeDto stopDto) {
        log.info("StopChargeDto:" + stopDto);
        return chargeService.stopImmediately(stopDto.getDeviceNo(), stopDto.getGunNo());
    }

    @PostMapping(value = "queryChargeHistory")
    public Object queryChargeHistory(@RequestBody QueryChargeDto queryDto) {
        log.info("QueryChargeDto:"+queryDto);
        return chargeService.queryChargeHistory(queryDto.getDeviceNo(), queryDto.getBackIndex());
    }

    @PostMapping(value = "setChargeRate")
    public Object setChargeRate(@RequestBody SetRatesDto ratesDto){
        log.info("setChargeRate:"+ratesDto);
//        return 123;
        return chargeService.setChargeRate(ratesDto.getDeviceNo(), ratesDto.getRates());
    }
}
