package com.zhili.stationcontrol.gatewayserver.handler;

import com.zhili.stationcontrol.gatewayserver.dto.GatewayMessage;
import com.zhili.stationcontrol.util.BytesUtil;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.ByteToMessageDecoder;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.ArrayUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2022/10/28 15:28
 */
@Slf4j
public class GatewayMessageDecoder extends ByteToMessageDecoder {
//    public static final byte[] START = {(byte) 0xaa, (byte) 0x7e};
    public static final byte[] START = {(byte) 0xaa, (byte) 0xf5};

    @Override
    protected void decode(ChannelHandlerContext channelHandlerContext, ByteBuf byteBuf, List<Object> list) throws Exception {
        while (byteBuf.readableBytes() >= START.length) {
            byteBuf.markReaderIndex();
            byte[] start = new byte[2];
            byteBuf.readBytes(start);
            if (start[0] == START[0] && start[1] == START[1]) {
                //读到头部，读长度
                log.info("读到头部");
                if (byteBuf.readableBytes() >= 2) {
                    byte[] lenBytes = new byte[2];
                    byteBuf.readBytes(lenBytes);
                    int len = BytesUtil.toIntWithLowerFirst(lenBytes);
                    log.info("读到长度：" + len);
                    //读剩余的数据
                    if (byteBuf.readableBytes() >= len - 4) {
                        byte[] last = new byte[len - 4];
                        byteBuf.readBytes(last);
                        int size = last.length / 13;
                        log.info("共有底座消息： "+size+" 个");
                        List<GatewayMessage> messages = new ArrayList();
                        for (int i = 0; i < size; i++) {
                            GatewayMessage msg = new GatewayMessage();
                            byte[] msgId = ArrayUtils.subarray(last, i * 13 + 1, i * 13 + 5);
                            msg.setId(BytesUtil.toIntWithLowerFirst(msgId));
                            byte[] data = ArrayUtils.subarray(last, i * 13 + 5, i * 13 + 13);
                            msg.setData(data);
                            messages.add(msg);
                        }
                        list.add(messages);
                    } else {
                        //读不出一个整体的包，等待数据再读
                        byteBuf.resetReaderIndex();
                        return;
                    }
                } else {
                    //长度字段不够读，下次再读；
                    byteBuf.resetReaderIndex();
                    return;
                }
            } else {
                //没有读到头部，继续往后读
                byteBuf.resetReaderIndex();
                byteBuf.skipBytes(1);
//                byteBuf.readByte();
            }
        }
    }
}
