package com.zhili.stationcontrol.gatewayserver.handler;

import com.zhili.stationcontrol.gatewayserver.dto.GatewayMessage;
import com.zhili.stationcontrol.util.BytesUtil;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToByteEncoder;
import org.apache.commons.lang.ArrayUtils;

import java.util.List;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2022/10/28 15:28
 */
public class GatewayMessageEncoder extends MessageToByteEncoder<List<GatewayMessage>> {

    public static final byte[] START = {(byte) 0xaa, (byte) 0x7e};

    @Override
    protected void encode(ChannelHandlerContext channelHandlerContext, List<GatewayMessage> messages, ByteBuf byteBuf) throws Exception {
        //写入头部
        byteBuf.writeBytes(START);
        //写入长度
        int dataLen = messages.size() * 13;
        int len = dataLen + 4;
        byteBuf.writeBytes(BytesUtil.fromIntWithLowerFirst(len, 2));
        //写入数据
        for (int i = 0; i < messages.size(); i++) {
            GatewayMessage msg = messages.get(i);
            int id = msg.getId();
            byte[] data = msg.getData();
            //写 填充位
            byteBuf.writeByte((byte) 0x88);
            //写 id
            byteBuf.writeBytes(BytesUtil.fromIntWithLowerFirst(id, 4));
            //写 data
            byteBuf.writeBytes(ArrayUtils.subarray(data, 0, 8));
        }
    }
}
