package com.zhili.stationcontrol.gatewayserver.handler;

import com.zhili.stationcontrol.gatewayserver.dto.GatewayMessage;
import com.zhili.stationcontrol.gatewayserver.util.GatewayCenter;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;
import lombok.extern.slf4j.Slf4j;

import java.util.List;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2022/10/28 15:28
 */

@Slf4j
public class GatewayMessageHandler extends ChannelInboundHandlerAdapter {
    @Override
    public void channelActive(ChannelHandlerContext ctx) throws Exception {
        log.info("channel connected: "+ctx.channel().remoteAddress().toString());
        GatewayCenter.add(ctx.channel());
        super.channelActive(ctx);
    }

    @Override
    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
        if (msg instanceof List) {
            List<GatewayMessage> messages = (List<GatewayMessage>) msg;
            for (int i = 0; i < messages.size(); i++) {
                GatewayMessage m = messages.get(i);
                log.info("接收到网关消息：" + m);
            }
            ctx.writeAndFlush(messages);
        }
    }

    @Override
    public void channelInactive(ChannelHandlerContext ctx) throws Exception {
        log.info("连接断开:"+ctx.channel().remoteAddress().toString());
        super.channelInactive(ctx);
    }
}
