package com.zhili.stationcontrol.util;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2022/10/18 14:00
 */
public class BytesUtil {
    public static byte[] fromIntWithHigherFirst(int intVal, int bytesLen) {
        byte[] bytes5 = new byte[bytesLen];
        while (bytesLen > 0) {
            bytesLen--;
            bytes5[bytesLen] = (byte) (intVal >> 8 * (bytes5.length - bytesLen - 1) & 0xFF);
        }
        return bytes5;
    }

    public static byte[] fromIntWithLowerFirst(int intVal, int bytesLen) {
        byte[] bytes5 = new byte[bytesLen];
        while (bytesLen > 0) {
            bytesLen--;
            bytes5[bytes5.length - bytesLen - 1] = (byte) (intVal >> 8 * (bytes5.length - bytesLen - 1) & 0xFF);
        }
        return bytes5;
    }

    public static int toIntWithLowerFirst(byte[] bytes) {
        int length = bytes.length;
        int res = 0;
        for (int i = 0; i < length; i++) {
            res = res * 256;
            res += Byte.toUnsignedInt(bytes[length - i - 1]);
        }
        return res;
    }

    public static byte sumCheck(byte[] b) {
        int sum = 0;
        for (int i = 0; i < b.length; i++) {
            sum = sum + b[i];
            sum = 0xff & sum;
        }
        return (byte) sum;
    }

    public static String parseString(byte[] b) {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < b.length; i++) {
            sb.append((char) b[i]);
        }
        String rawString = sb.toString();
        int k = rawString.indexOf(0);
        return rawString.substring(0, k);
    }

    public static byte[] fromString(String s, int len, byte fill) {
        byte[] res = new byte[len];
        for (int i = 0; i < s.length(); i++) {
            byte b = (byte) s.charAt(i);
            res[i] = b;
        }
        for(int j=s.length();j<len;j++){
            res[j]=fill;
        }
        return res;
    }

    public static void setSubBytes(byte[] source, int index, byte[] target) {
        for (int i = 0; i < target.length; i++) {
            source[index + i] = target[i];
        }
    }

    public static byte[] composeNowTimeBytes() {
        LocalDateTime now = LocalDateTime.now();
        String timeStr = DateTimeFormatter.ofPattern("yyyyMMddHHmmss").format(now);
        byte[] timeBytes = new byte[8];
        for (int i = 0; i < 7; i++) {
            String partStr = timeStr.substring(2 * i, 2 * (i + 1));
            timeBytes[i] = BytesUtil.fromIntWithLowerFirst(Integer.valueOf(partStr, 16), 1)[0];
        }
        timeBytes[7] = (byte) 0xff;
        return timeBytes;
    }

    public static String composeTimeString(byte[] timeBytes) {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < timeBytes.length - 1; i++) {
            byte b = timeBytes[i];
            String partStr = Integer.toHexString(Byte.toUnsignedInt(b));
            if (partStr.length() == 1) {
                partStr = "0" + partStr;
            }
            sb.append(partStr);
//            2015-02-13 12:00:12
            if (i < 1 || i >= 6) {

            } else if (i < 3) {
                sb.append("-");
            } else if (i < 4) {
                sb.append(" ");
            } else if (i < 6) {
                sb.append(":");
            }
        }
        return sb.toString();
    }

}
