import com.intelligt.modbus.jlibmodbus.Modbus;
import com.intelligt.modbus.jlibmodbus.exception.ModbusIOException;
import com.intelligt.modbus.jlibmodbus.exception.ModbusNumberException;
import com.intelligt.modbus.jlibmodbus.exception.ModbusProtocolException;
import com.intelligt.modbus.jlibmodbus.master.ModbusMaster;
import com.intelligt.modbus.jlibmodbus.master.ModbusMasterFactory;
import com.intelligt.modbus.jlibmodbus.tcp.TcpParameters;
import com.zhili.stationcontrol.util.BytesUtil;
import lombok.extern.log4j.Log4j2;
import org.junit.Test;
import org.springframework.boot.test.context.SpringBootTest;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Arrays;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2022/10/18 14:01
 */
@SpringBootTest
@Log4j2
public class SomeTest {

    @Test
    public void test() {
        byte[] bytes = BytesUtil.fromIntWithHigherFirst(256, 2);
        log.info(Arrays.toString(bytes));
    }

    @Test
    public void test1() {
        byte[] bytes = BytesUtil.fromIntWithLowerFirst(256, 2);
        log.info(Arrays.toString(bytes));
        int i = BytesUtil.toIntWithLowerFirst(bytes);
        log.info(i);
    }

    @Test
    public void test2() {
        int a = 'a';
        log.info(a);
    }

    @Test//291.762999999992
    public void testModbusRead() throws UnknownHostException, ModbusProtocolException, ModbusNumberException, ModbusIOException {
        TcpParameters tcpParameters = new TcpParameters();
//        tcpParameters.setHost(InetAddress.getByName("127.0.0.1"));
        tcpParameters.setHost(InetAddress.getByName("192.168.3.88"));
        tcpParameters.setKeepAlive(true);
        tcpParameters.setPort(502);
        ModbusMaster master = ModbusMasterFactory.createModbusMasterTCP(tcpParameters);
        Modbus.setAutoIncrementTransactionId(true);
//        master.writeSingleRegister(1,65536,1);

        master.writeSingleCoil(1, 1000, true);
//        boolean[] booleans = master.readCoils(1, 13702, 1);
//        System.out.println(booleans[0]);
//        int[] data = new int[4];
//        data[0]=60816;
//        data[1]=16252;
//        data[2]=15413;
//        data[3]=16498;
//        master.writeMultipleRegisters(1, 8105, data);
//        int[] ints = master.readHoldingRegisters(1, 8000, 4);
//        Double aDouble = PLCUtil.parseFloat64(ints);
//        log.info("-----"+aDouble);
//        int[] ints1 = PLCUtil.composeFloat64(aDouble);
//        master.writeMultipleRegisters(1, 8100, ints1);
    }

    @Test
    public void testx(){
        String res1 = Integer.toHexString(60816);
        System.out.println(res1);
        String res2 = Integer.toHexString(16252);
        System.out.println(res2);
        String res3 = Integer.toHexString(15413);
        System.out.println(res3);
        String res4 = Integer.toHexString(16498);
        System.out.println(res4);
//        ed90
//        3f7c
//        3c35
//        4072
//        291.762999999992
        String hexString ="40723c353f7ced90";//倒序ping
        long longBits = Long.valueOf(hexString,16).longValue();
        double doubleValue = Double.longBitsToDouble(longBits);
        System.out.println("double float hexString is =" + doubleValue);
//        Double.toHexString()
    }

//    @Test
//    public void testx1(){
//        int[] ints = PLCUtil.composeFloat64(291.762999999999);
//        for(int i=0;i<ints.length;i++){
//            log.info(ints[i]);
//        }
//    }
//    \xaa\xf7\x0a\x00\x13\x00\x12\x00\x25
    @Test
    public void testChecksum(){
        byte[] bs = new byte[9];
        bs[0]=(byte)0xaa;
        bs[1]=(byte)0xf7;
        bs[2]=(byte)0x0a;
        bs[3]=(byte)0x00;
        bs[4]=(byte)0x13;
        bs[5]=(byte)0x00;
        bs[6]=(byte)0x12;
        bs[7]=(byte)0x00;
        bs[8]=(byte)0x25;
        byte b = BytesUtil.sumCheck(bs);
        log.info("!!!!"+b);
    }

    @Test
    public void testObj(){
        Object a="123";
        String b="123";
        log.info(a.equals(b));
    }

    @Test
    public void testB(){
        byte[] source = new byte[5];
        log.info(source);
        byte[] target = new byte[2];
        target[0]=12;
        target[1]=13;
        BytesUtil.setSubBytes(source,2,target);
        for(int i=0;i<source.length;i++){
            log.info(source[i]);
        }
    }

    @Test
    public void testTimeBytes(){
        byte[] bytes = BytesUtil.composeNowTimeBytes();
        for(int i=0;i<bytes.length;i++){
            System.out.println(bytes[i]);
        }
    }

    @Test
    public void testStr(){
        byte[] bytes = new byte[5];
        bytes[0] = (byte)97;
        bytes[1] = (byte)98;
        String s = BytesUtil.parseString(bytes);
        log.info(s);
    }

    @Test
    public void testTime(){
        byte[] tBytes = new byte[8];
        tBytes[0]=0x20;
        tBytes[1]=0x15;
        tBytes[2]=0x03;
        tBytes[3]=0x23;
        tBytes[4]=0x17;
        tBytes[5]=0x31;
        tBytes[6]=0x15;
        tBytes[7]=(byte)0xff;
        String s = BytesUtil.composeTimeString(tBytes);
        log.info(s);
    }
    @Test
    public void testStrBytes(){
        byte[] bytes = BytesUtil.fromString("ab", 5, (byte) 0xff);
        for(int i=0;i<bytes.length;i++){
            log.info(Byte.toUnsignedInt(bytes[i]));
        }
    }

}
//        16:45:40.720 [main] INFO SomeTest - 60816
//        16:45:40.725 [main] INFO SomeTest - 16252
//        16:45:40.725 [main] INFO SomeTest - 15413
//        16:45:40.725 [main] INFO SomeTest - 16498